/**********************************************************************
Critical value generating program in the first panel of Table 1

2nd column of thr matrix yields the asymptotic null distribution.

3rd column yields the asymptotic null distribution without considering
    boundary parameter problem. 

***********************************************************************/
new;
library pgraph;

m0 = 0;
s1 = 1;
nm = 303;                                                                      /* # of grid points */
bv = -1.0;                                                                     /* Left ending point of parameter space */     
uv = 1.0;                                                                      /* Right ending point of parameter space */         
mu = seqa(bv, (uv-bv)/nm, nm+1);
de = (mu - m0)/s1;
dn = sqrt(exp(de^2) - 1 - de^2);
mm = 150;
kk = 10000;                                                                     /* # of iterations */
td = zeros(kk,4);

dd = 1;
do until dd > kk;

    yn = rndn(mm,1);
    nr = zeros(nm+1,1); 
    jj = 1;
    do until jj > nm+1;
        psu = zeros(mm,1);
        ii = 1;
        do until ii > mm;
            psu[ii,1] = yn[ii,1]*de[jj,1]^(ii+1)/sqrt((ii+1)!);
            ii = ii + 1;
        endo;
        nr[jj,1] = sumc(psu[.,1]);
        jj = jj + 1;
    endo;

    qsu = zeros(nm+1,3);
    qsu[.,1] = nr./dn;
    jj = 1;
    do until jj > nm+1; 
        qsu[jj,3] = maxc(qsu[jj,1:2]');
        jj = jj + 1;
    endo;
    td[dd,1] = maxc(qsu[.,3]);
    td[dd,2] = maxc(qsu[.,3])^2;
    td[dd,3] = maxc(qsu[.,1]^2);
    td[dd,4] = dd/kk;
    dd = dd + 1;
endo;

td[.,1] = sortc(td[.,1],1);
td[.,2] = sortc(td[.,2],1);
td[.,3] = sortc(td[.,3],1);

output file = mixlrcv_1pn_n1p0_p1p0.out reset;                                  /* Output file name */
screen off;
print td;
screen on;
output off;
