/**********************************************************************
Critical value generating program in the Second panel of Table 1

4th column of thr matrix yields the asymptotic null distribution.

5th column yields the asymptotic null distribution without considering
    boundary parameter problem. 

**********************************************************************/

new;
library pgraph cml;
#include cml.ext;
CMLset;
_pdate = {0};
_pgrid = {1, 1};
a = time;

kkk = 10000;                                                /* Number of Iterations */

grdn = 243;                                                 /* Number of grid points */
bot = -1.2;                                                 /* Left ending value of parameter space */
cei = 1.2;                                                  /* Right ending value of parameter space */
mu2s = seqa(bot, (cei-bot)/grdn, grdn+1);
nnrm = 150;
denm = zeros(grdn+1,1);
iii = 1;
do until iii > grdn+1;
    denm[iii,1] = sqrt(exp(mu2s[iii,1]^2) - 1 - mu2s[iii,1]^2 -0.5*mu2s[iii,1]^4 );
    iii = iii + 1;
endo;

thr = zeros(kkk,13);
iii = 1;
do until iii > kkk;
    yyy = rndn(nnrm,1);
    qwe = zeros(nnrm,1);
    dcv = zeros(grdn+1,3);
    jjj = 1;
    do until jjj > grdn+1;
        hhh = 3;
        do until hhh > nnrm;
            qwe[hhh,1] = mu2s[jjj,1]^hhh*yyy[hhh,1]/sqrt(hhh!);
            hhh = hhh + 1;
        endo;
        dcv[jjj,1] = sumc(qwe[.,1]);
        dcv[jjj,2] = dcv[jjj,1]/denm[jjj,1];
        vvv = zeros(2,1);
        vvv[1,1] = dcv[jjj,2];
        dcv[jjj,3] = maxc(vvv);
        jjj = jjj + 1;
    endo;
    sdf = zeros(2,1);
    sdf[1,1] = yyy[4,1]; 
    thre = zeros(2,1);
    thre[1,1] = maxc(dcv[.,3])^2;
    thre[2,1] = minc(sdf)^2;
    thr[iii,1] = maxc(thre);
    rgt = zeros(2,1);
    rgt[1,1] = maxc(dcv[.,2]^2);
    rgt[2,1] = minc(sdf)^2;
    thr[iii,2] = maxc(rgt);
    thr[iii,13] = iii/kkk;
    iii = iii + 1;
endo;

xy(mu2s,dcv[.,2]);

thr[.,4] = sortc(thr[.,1],1);
thr[.,5] = sortc(thr[.,2],1);

output file = 2ndex_n1p2top1p2.asc reset;                      /* Output file name */
screen off;
print thr;
output off;
screen on;
